package com.bestv.edu.activity;

import android.app.Activity;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;

import androidx.annotation.Nullable;

import com.hpplay.sdk.source.api.IBindSdkListener;
import com.hpplay.sdk.source.api.LelinkSourceSDK;
import com.hpplay.sdk.source.browse.api.IAPI;
import com.hpplay.sdk.source.browse.api.IBrowseListener;
import com.hpplay.sdk.source.browse.api.LelinkServiceInfo;
import com.hpplay.sdk.source.easycast.IEasyCastListener;
import com.hpplay.sdk.source.easycast.bean.EasyCastBean;
import com.shuyu.gsyvideoplayer.GSYVideoManager;
import com.shuyu.gsyvideoplayer.utils.OrientationUtils;
import com.bestv.edu.R;
import com.bestv.edu.view.VideoPreviewPlay;

import java.util.List;

/**
 * author : 程中强
 * e-mail : 740479946@qq.com
 * date : 2022/9/1417:18
 * desc :
 * version: 1.0
 */
public class GSXYVideoPlayerActivity extends Activity {

	VideoPreviewPlay videoPlayer;
	private OrientationUtils orientationUtils;
	private Button btn;
	private boolean isFirst = false;
	private ViewGroup mBrowseContainer;

	private String url = "http://v3.cztv.com/cztv/vod/2018/06/28/7c45987529ea410dad7c088ba3b53dac/h264_1500k_mp4.mp4";
	@Override
	protected void onCreate(@Nullable Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_gsxy_video);
		init();
		mBindSdkListener = new IBindSdkListener() {
			@Override
			public void onBindCallback(boolean success) {
				Log.e("LeBo","初始化:"+success);
			}
		};

//		LelinkSourceSDK.getInstance().setEasyCastListener(mCastListener);
		LelinkSourceSDK.getInstance().setBrowseResultListener(browserListener);
	}
	private IBindSdkListener mBindSdkListener;
	void initLebo(){

		LelinkSourceSDK.getInstance().startBrowse();
//		LelinkSourceSDK.getInstance()
////				.setBindSdkListener(mBindSdkListener)
//				//FIXME WARN: 这里替换为您申请的AppID & AppSecret，build.gradle替换为您的应用包名 com.bestv.edu  原com.xunao.effectdemo
////				.setSdkInitInfo(this, "20268", "30ff4917114c5241eddbef00e5be7f6b")
//				.easyPush(mBrowseContainer);

	}
	private IBrowseListener browserListener = new IBrowseListener() {

		@Override
		public void onBrowse(int resultCode, List<LelinkServiceInfo> list) {
			Log.e("MyTag","搜索:"+resultCode+"   "+IBrowseListener.BROWSE_SUCCESS);
		}
	};
	private IEasyCastListener mCastListener = new IEasyCastListener() {

		/**
		 * 如果没有触发此回调，则表示此次未搜索到设备或用户未投屏
		 * @param lelinkServiceInfo
		 * @return
		 */
		@Override
		public EasyCastBean onCast(LelinkServiceInfo lelinkServiceInfo) {
			EasyCastBean bean = new EasyCastBean();
			bean.url = url; //实际需要投屏的url
			return bean;
		}

		/**
		 * 如果投屏失败，在搜索页面关闭的时候，会触发回调
		 * @param lelinkServiceInfo
		 * @param easyCastBean
		 * @param what
		 * @param extra
		 */
		@Override
		public void onCastError(LelinkServiceInfo lelinkServiceInfo, EasyCastBean easyCastBean, int what, int extra) {
		}

		/**
		 * 推送成功
		 * @param lelinkServiceInfo
		 * @param easyCastBean
		 */
		@Override
		public void onCastLoading(LelinkServiceInfo lelinkServiceInfo, EasyCastBean easyCastBean) {
		}

		/**
		 * 暂停
		 * @param lelinkServiceInfo
		 * @param easyCastBean
		 */
		@Override
		public void onCastPause(LelinkServiceInfo lelinkServiceInfo, EasyCastBean easyCastBean) {
		}

		/**
		 * 起播 或 收端暂停之后恢复播放
		 * @param lelinkServiceInfo
		 * @param easyCastBean
		 */
		@Override
		public void onCastStart(LelinkServiceInfo lelinkServiceInfo, EasyCastBean easyCastBean) {
		}

		@Override
		public void onCastPositionUpdate(LelinkServiceInfo lelinkServiceInfo, EasyCastBean easyCastBean, long duration, long position) {
		}

		/**
		 * 收端播放结束，如果需要实现下一集，可在之后的onCast回调中提供播放信息
		 * @param lelinkServiceInfo
		 * @param easyCastBean
		 */
		@Override
		public void onCastCompletion(LelinkServiceInfo lelinkServiceInfo, EasyCastBean easyCastBean) {
		}

		/**
		 * 搜索退出播放，不同于 onCastCompletion，此时需要恢复APP视频播放
		 * @param lelinkServiceInfo
		 * @param easyCastBean
		 */
		@Override
		public void onCastStop(LelinkServiceInfo lelinkServiceInfo, EasyCastBean easyCastBean) {
		}

		@Override
		public void onDismiss() {
		}
	};

	void init(){
		videoPlayer = findViewById(R.id.video_play);
		videoPlayer.setUp(url, true, "null");

		mBrowseContainer = findViewById(R.id.mBrowseContainer);

		//增加title
		videoPlayer.getTitleTextView().setVisibility(View.GONE);
		//设置返回键
		videoPlayer.getBackButton().setOnClickListener(v->{
			finish();
		});
		videoPlayer.getFullscreenButton().setVisibility(View.GONE);
		orientationUtils = new OrientationUtils(this, videoPlayer);
		videoPlayer.setIsFinish(isFirst);
		videoPlayer.setIsTouchWiget(isFirst);
		videoPlayer.setIsTouchWigetFull(isFirst);
		videoPlayer.setIfCurrentIsFullscreen(false);
//		videoPlayer.startPlayLogic();

		btn = findViewById(R.id.btn_finish);
		btn.setOnClickListener(v->{
			videoPlayer.onVideoPause();
//			isFirst = !isFirst;
//			videoPlayer.setIsFinish(isFirst);
			mBrowseContainer.setVisibility(View.VISIBLE);
			initLebo();
		});
	}

	@Override
	protected void onResume() {
		super.onResume();
		videoPlayer.onVideoResume();
	}

	@Override
	protected void onPause() {
		super.onPause();
		videoPlayer.onVideoPause();
	}

	@Override
	protected void onDestroy() {
		super.onDestroy();
		GSYVideoManager.releaseAllVideos();
		if (orientationUtils != null)
			orientationUtils.releaseListener();
	}

//	@Override
//	public void onBackPressed() {
//		//先返回正常状态
//		if (orientationUtils.getScreenType() == ActivityInfo.SCREEN_ORIENTATION_LANDSCAPE) {
//			videoPlayer.getFullscreenButton().performClick();
//			return;
//		}
//		//释放所有
//		videoPlayer.setVideoAllCallBack(null);
//		super.onBackPressed();
//	}
}
